Properties Methods Events Direct Link

    DragDrop
      DDTarget

# Class Ext.dd.DDTarget

Package: | Ext.dd
Defined In: | DDCore.js
Class: | DDTarget
Subclasses: | DropTarget
Extends: | DragDrop

A DragDrop implementation that does not move, but can be a drop target. You would get the same result by simply omitting implementation for the event callbacks, but this way we reduce the processing cost of the event listener and the callbacks.

## Public Properties

Property | Defined By
--- | ---
| available : boolean The available property is false until the linked dom element is accessible. | DragDrop
| config : object Configuration attributes passed into the constructor | DragDrop
| defaultPadding : Object Provides default constraint padding to "constrainTo" elements (defaults to {left: 0, right:0, top:0, bottom:0}). | DragDrop

groups : object An object in the format {'group1':true, 'group2':true
The group defines a logical collection of DragDrop objects that are related. Instances only get events when interact...
The group defines a logical collection of DragDrop objects that are related. Instances only get events when interacting with other DragDrop object in the same group. This lets us define multiple groups using a single DragDrop subclass if we want.

DragDrop

hasOuterHandles : boolean
By default, drags can only be initiated if the mousedown occurs in the region the linked element is. This is done in...
By default, drags can only be initiated if the mousedown occurs in the region the linked element is. This is done in part to work around a bug in some browsers that mis-report the mousedown if the previous mouseup happened outside of the window. This property is set to true if outer handles are defined.

DragDrop

| id : String The id of the element associated with this object. This is what we refer to as the "linked element" because the size... The id of the element associated with this object. This is what we refer to as the "linked element" because the size and position of this element is used to determine when the drag and drop objects have interacted. | DragDrop
| ignoreSelf : Boolean Set to false to enable a DragDrop object to fire drag events while dragging over its own Element. Defaults to true - ... Set to false to enable a DragDrop object to fire drag events while dragging over its own Element. Defaults to true - DragDrop objects do not by default fire drag events to themselves. | DragDrop
| invalidHandleClasses : Array An Array of CSS class names for elements to be considered in valid as drag handles. | DragDrop

invalidHandleIds : Object
An object who's property names identify the IDs of elements to be considered invalid as drag handles. A non-null prop...
An object who's property names identify the IDs of elements to be considered invalid as drag handles. A non-null property value identifies the ID as invalid. For example, to prevent dragging from being initiated on element ID "foo", use:

    {
        foo: true
    }

DragDrop

invalidHandleTypes : Object
An object who's property names identify HTML tags to be considered invalid as drag handles. A non-null property value...
An object who's property names identify HTML tags to be considered invalid as drag handles. A non-null property value identifies the tag as invalid. Defaults to the following value which prevents drag operations from being initiated by <a> elements:

    {
        A: "A"
    }

DragDrop

| isTarget : boolean By default, all instances can be a drop target. This can be disabled by setting isTarget to false. | DragDrop
| maintainOffset : boolean Maintain offsets when we resetconstraints. Set to true when you want the position of the element relative to its par... Maintain offsets when we resetconstraints. Set to true when you want the position of the element relative to its parent to stay the same when the page changes | DragDrop
| moveOnly : boolean When set to true, other DD objects in cooperating DDGroups do not receive notification events when this DD object is ... When set to true, other DD objects in cooperating DDGroups do not receive notification events when this DD object is dragged over them. Defaults to false. | DragDrop
| padding : int[] An array containing the 4 padding values: [top, right, bottom, left] The padding configured for this drag and drop object for calculating the drop zone intersection with this object. | DragDrop
| primaryButtonOnly : boolean By default the drag and drop instance will only respond to the primary button click (left button for a right-handed m... By default the drag and drop instance will only respond to the primary button click (left button for a right-handed mouse). Set to true to allow drag and drop to start with any mouse click that is propogated by the browser | DragDrop
| xTicks : int[] Array of pixel locations the element will snap to if we specified a horizontal graduation/interval. This array is ge... Array of pixel locations the element will snap to if we specified a horizontal graduation/interval. This array is generated automatically when you define a tick interval. | DragDrop
| yTicks : int[] Array of pixel locations the element will snap to if we specified a vertical graduation/interval. This array is gene... Array of pixel locations the element will snap to if we specified a vertical graduation/interval. This array is generated automatically when you define a tick interval. | DragDrop

## Public Methods

Method | Defined By
--- | ---

DDTarget( `String id`, `String sGroup`, `object config` )
Parameters:

- `id` : String
  the id of the element that is a drop target
- `sGroup` : String
  the group of related DragDrop objects
- `config` : object
  an object containing configurable attributes Valid properties for DDTarget in addition to those in DragDrop: none

Returns:

- void

DDTarget

addToGroup( `sGroup {string}` ) : void
Add this instance to a group of related drag/drop objects. All instances belong to at least one group, and can belon...
Add this instance to a group of related drag/drop objects. All instances belong to at least one group, and can belong to as many groups as needed.
Parameters:

- `{string}` : sGroup
  the name of the group

Returns:

- void

DragDrop

applyConfig() : void
Applies the configuration parameters that were passed into the constructor. This is supposed to happen at each level ...
Applies the configuration parameters that were passed into the constructor. This is supposed to happen at each level through the inheritance chain. So a DDProxy implentation will execute apply config on DDProxy, DD, and DragDrop in order to get all of the parameters that are available in each object.
Parameters:

- None.

Returns:

- void

DragDrop

constrainTo( `Mixed constrainTo`, [`Object/Number pad`], [`Boolean inContent`] ) : void
Initializes the drag drop object's constraints to restrict movement to a certain element. Usage: var dd = new Ext.dd...
Initializes the drag drop object's constraints to restrict movement to a certain element. Usage:

    var dd = new Ext.dd.DDProxy("dragDiv1", "proxytest",
                    { dragElId: "existingProxyDiv" });
     dd.startDrag = function(){
         this.constrainTo("parent-id");
     };

Or you can initalize it using the Ext.Element object:

    Ext.get("dragDiv1").initDDProxy("proxytest", {dragElId: "existingProxyDiv"}, {
         startDrag : function(){
             this.constrainTo("parent-id");
         }
     });

Parameters:

- `constrainTo` : Mixed
  The element to constrain to.
- `pad` : Object/Number
  (optional) Pad provides a way to specify "padding" of the constraints, and can be either a number for symmetrical padding (4 would be equal to {left:4, right:4, top:4, bottom:4}) or an object containing the sides to pad. For example: {right:10, bottom:10}
- `inContent` : Boolean
  (optional) Constrain the draggable in the content box of the element (inside padding and borders)

Returns:

- void

DragDrop

getEl() : HTMLElement
Returns a reference to the linked element
Returns a reference to the linked element
Parameters:

- None.

Returns:

- `HTMLElement`
  the html element

DragDrop

init( `id the`, `String sGroup`, `object config` ) : void
Sets up the DragDrop object. Must be called in the constructor of any Ext.dd.DragDrop subclass
Sets up the DragDrop object. Must be called in the constructor of any Ext.dd.DragDrop subclass
Parameters:

- `the` : id
  id of the linked element
- `sGroup` : String
  the group of related items
- `config` : object
  configuration attributes

Returns:

- void

DragDrop

initTarget( `id the`, `String sGroup`, `object config` ) : void
Initializes Targeting functionality only... the object does not get a mousedown handler.
Initializes Targeting functionality only... the object does not get a mousedown handler.
Parameters:

- `the` : id
  id of the linked element
- `sGroup` : String
  the group of related items
- `config` : object
  configuration attributes

Returns:

- void

DragDrop

isLocked() : boolean
Returns true if this instance is locked, or the drag drop mgr is locked (meaning that all drag/drop is disabled on th...
Returns true if this instance is locked, or the drag drop mgr is locked (meaning that all drag/drop is disabled on the page.)
Parameters:

- None.

Returns:

- `boolean`
  true if this obj or all drag/drop is locked, else false

DragDrop

lock() : void
Lock this instance
Lock this instance
Parameters:

- None.

Returns:

- void

DragDrop

onAvailable() : void
Override the onAvailable method to do what is needed after the initial position was determined.
Override the onAvailable method to do what is needed after the initial position was determined.
Parameters:

- None.

Returns:

- void

DragDrop

removeFromGroup( `string sGroup` ) : void
Remove's this instance from the supplied interaction group
Remove's this instance from the supplied interaction group
Parameters:

- `sGroup` : string
  The group to drop

Returns:

- void

DragDrop

setPadding( `int iTop`, `int iRight`, `int iBot`, `int iLeft` ) : void
Configures the padding for the target zone in px. Effectively expands (or reduces) the virtual object size for targe...
Configures the padding for the target zone in px. Effectively expands (or reduces) the virtual object size for targeting calculations. Supports css-style shorthand; if only one parameter is passed, all sides will have that padding, and if only two are passed, the top and bottom will have the first param, the left and right the second.
Parameters:

- `iTop` : int
  Top pad
- `iRight` : int
  Right pad
- `iBot` : int
  Bot pad
- `iLeft` : int
  Left pad

Returns:

- void

DragDrop

toString() : string
toString method
toString method
Parameters:

- None.

Returns:

- `string`
  string representation of the dd obj

DragDrop

unlock() : void
Unlock this instace
Unlock this instace
Parameters:

- None.

Returns:

- void

DragDrop

unreg() : void
Remove all drag and drop hooks for this element
Remove all drag and drop hooks for this element
Parameters:

- None.

Returns:

- void

DragDrop

## Public Events

This class has no public events.